import {infer} from '../generic/infer'

export const square = infer(<T>(dep: {
  multiply: (a: number, b: number) => number,
  unaryMinus: (x: number) => number, // just for the experiment
}): (a: number) => number =>
  z => dep.multiply(z, z)
)
